//Solution to supplement experiment 13(a)
//HDL description of 74189 16x4 RAM.
module _74189 (DataIn, DataOut, Addr, CS, WE);
input [3:0] DataIn, Addr;
input CS, WE;         // CS and WE active-low. 
output [3:0] DataOut; //Hi-Z during write or if memory disabled.
tri [3:0] DataOut;    //Three-state output.
reg [3:0] Ram [0:15]; //16 x 4 memeory.
assign DataOut = (~CS && WE) ? ~Ram[Addr] : 4'bz;
always @(CS or WE or DataIn or Addr)
  if (~CS && ~WE) Ram[Addr] = DataIn;
endmodule

