//Solution to supplement Experiment 14
//DESCRIPTION Of 74194 SHIFT-REGISTER (Fig. 11-19)
module _74194(Q, DataIn, SIR, SIL, S1, S0, Clk, Clr);
input SIR, SIL, S1, S0, Clk, Clr; //Clr is async active-low.
input [1:4] DataIn;// 1,2,3,4 => A,B,C,D in Fig.11-19
output [1:4] Q;
reg [1:4] Q;
wire S1, S0;
parameter NoChange = 2'b00, Shr = 2'b01, Shl = 2'b10, Ld = 2'b11;
always @(posedge Clk or negedge Clr)
  if (~Clr) Q = 0;
  else 
   case ({S1,S0})
     NoChange: Q = Q;
     Shr:      Q = {SIR,Q[1:3]};
     Shl:      Q = {Q[2:4],SIL};
     Ld:       Q = DataIn;
   endcase
endmodule

